import 'package:matrix/matrix.dart';

abstract class CallStateProxy {
  String? get displayName;
  bool get isMicrophoneMuted;
  bool get isLocalVideoMuted;
  bool get isScreensharingEnabled;
  bool get isRemoteOnHold;
  bool get localHold;
  bool get remoteOnHold;
  bool get voiceonly;
  bool get connecting;
  bool get connected;
  bool get ended;
  bool get callOnHold;
  bool get isOutgoing;
  bool get ringingPlay;
  String get callState;

  void answer();

  void hangup();

  void enter();

  void setMicrophoneMuted(bool muted);

  void setLocalVideoMuted(bool muted);

  void setScreensharingEnabled(bool enabled);

  void setRemoteOnHold(bool onHold);

  WrappedMediaStream? get localUserMediaStream;

  WrappedMediaStream? get localScreenSharingStream;

  WrappedMediaStream? get primaryStream;

  List<WrappedMediaStream> get screenSharingStreams;

  List<WrappedMediaStream> get userMediaStreams;

  void onStateChanged(Function() callback);
}
